summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorNikos Mavrogiannopoulos <nmav@redhat.com>2017-01-13 12:45:55 +0100
committerNikos Mavrogiannopoulos <nmav@redhat.com>2017-01-13 12:45:55 +0100
commit9b233c21d339779190c7140cd0df6ea22990b903 (patch)
tree324dac677f9766df2b09d1b751f1a90ec353f11a
parentc14455b2d72e248190e8f13810e0aa25a36166af (diff)
downloadlibtasn1-9b233c21d339779190c7140cd0df6ea22990b903.tar.gz
tests: added missing file
-rwxr-xr-xtests/decoding-invalid-pkcs743
1 files changed, 43 insertions, 0 deletions
diff --git a/tests/decoding-invalid-pkcs7 b/tests/decoding-invalid-pkcs7
new file mode 100755
index 0000000..b91d725
--- /dev/null
+++ b/tests/decoding-invalid-pkcs7
@@ -0,0 +1,43 @@
+#!/bin/sh
+
+# Copyright (C) 2017 Free Software Foundation, Inc.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+srcdir="${srcdir:-.}"
+
+if ! test -z "${VALGRIND}";then
+VALGRIND="${LIBTOOL:-libtool} --mode=execute ${VALGRIND} --error-exitcode=7 --leak-check=no"
+fi
+TMPFILE=decoding-invalid.$$.tmp
+ASN1DECODING="${ASN1DECODING:-../src/asn1Decoding$EXEEXT}"
+ASN1PKIX="${ASN1PKIX:-pkix.asn}"
+
+# This tests an invalid input which caused an infinite recursion
+# to certain libtasn1 versions.
+
+for i in "${srcdir}/invalid-pkcs7/"*.der;do
+$VALGRIND $ASN1DECODING "$ASN1PKIX" "$i" PKIX1.pkcs-7-ContentInfo >$TMPFILE 2>&1
+ret=$?
+if test $ret != 1;then
+ echo "Decoding failed for $i"
+ cat $TMPFILE
+ exit 1
+fi
+echo "$(basename $i): ok"
+done
+
+rm -f $TMPFILE
+
+exit 0